﻿using System;

namespace HeuristicLab.Algorithms.PushGP.Attributes {
  [AttributeUsage(AttributeTargets.Class)]
  public class PushExpressionAttribute : Attribute {
    public readonly string StackName;
    public readonly string ExpressionName;

    public PushExpressionAttribute(string stackName, string expressionName) {
      this.StackName = stackName;
      this.ExpressionName = expressionName;
    }
  }
}
