﻿using System;
using System.Collections.Generic;

namespace HeuristicLab.Problems.PushGP.ProgramSynthesis {
  using System.Drawing;

  using HeuristicLab.Algorithms.PushGP.Expressions;
  using HeuristicLab.Common;
  using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;

  public class PushProgram : ExecExpandExpression, ISymbolicExpressionTree {
    public PushProgram(Expression[] state)
      : base(state) {
    }

    public PushProgram(ExecExpandExpression origin)
      : base(origin) {
    }

    public object Clone() {
      throw new NotImplementedException();
    }

    public IDeepCloneable Clone(Cloner cloner) {
      throw new NotImplementedException();
    }

    public string ItemName { get; private set; }

    public string ItemDescription { get; private set; }

    public Version ItemVersion { get; private set; }

    public Image ItemImage { get; private set; }

    public event EventHandler ItemImageChanged;

    public event EventHandler ToStringChanged;

    public IEnumerable<ISymbolicExpressionTreeNode> IterateNodesBreadth() {
      throw new NotImplementedException();
    }

    public IEnumerable<ISymbolicExpressionTreeNode> IterateNodesPrefix() {
      throw new NotImplementedException();
    }

    public IEnumerable<ISymbolicExpressionTreeNode> IterateNodesPostfix() {
      throw new NotImplementedException();
    }

    public ISymbolicExpressionTreeNode Root { get; set; }

    public int Length { get { return this.State.Length; } }

    public new int Depth { get { return base.Depth; } }
  }
}
